"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _filterElement = _interopRequireDefault(require("./_filter-element"));

var _insertElement = _interopRequireDefault(require("./_insert-element"));

var _helpers = require("../_helpers");

var _enums = require("../_enums");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = ({
  proxy,
  query,
  variables,
  mutationResult,
  operation,
  ID,
  element,
  customAdd,
  customRemove,
  errors,
  insertion,
  field,
  ordering
}) => {
  let targetElement;
  const proxyObject = {
    query,
    variables
  };
  if (variables && typeof variables === 'object' && Object.prototype.hasOwnProperty.call(variables, '__vars') && element.type === _enums.NO_PARAMS) delete proxyObject.variables;

  try {
    // Update data array
    let data = proxy.readQuery(_objectSpread({}, proxyObject));

    if ( // unfreeze whole data if data[element.name] array is frozen
    Array.isArray(data[element.name]) && Object.isFrozen(data[element.name])) {
      data = (0, _helpers.deepCopy)(data);
    }

    if (operation === 'REMOVE') {
      if (Array.isArray(data[element.name])) {
        // eslint-disable-next-line prefer-destructuring
        targetElement = (0, _filterElement.default)({
          element: data[element.name],
          mutationResult,
          ID,
          queryName: element.name,
          errors
        })[0];
        let customData;

        if (customRemove) {
          customData = customRemove({
            query: element.name,
            type: 'array',
            data: data[element.name],
            variables
          });
        }

        data[element.name] = customData && typeof customData === typeof data[element.name] ? customData : [...(0, _filterElement.default)({
          element: data[element.name],
          action: 'not-equal',
          mutationResult,
          ID,
          queryName: element.name,
          errors
        })];
      } else if (typeof data[element.name] === 'number') {
        targetElement = data[element.name];
        let customData;

        if (customRemove) {
          customData = customRemove({
            query: element.name,
            type: 'number',
            data: data[element.name],
            variables
          });
        }

        data[element.name] = customData && typeof customData === typeof data[element.name] ? customData : data[element.name] - 1;
      } else if (typeof data[element.name] === 'string') {
        targetElement = data[element.name];
        let customData;

        if (customRemove) {
          customData = customRemove({
            query: element.name,
            type: 'string',
            data: data[element.name],
            variables
          });
        }

        data[element.name] = customData && typeof customData === typeof data[element.name] ? customData : data[element.name];
      } else if (typeof data[element.name] === 'object') {
        targetElement = data[element.name];
        let customData;

        if (customRemove) {
          customData = customRemove({
            query: element.name,
            type: 'object',
            data: data[element.name],
            variables
          });
        }

        data[element.name] = customData && typeof customData === typeof data[element.name] && !Array.isArray(customData) && operation !== customData ? customData : data[element.name];
      }
    } else if (operation === 'ADD') {
      if (Array.isArray(data[element.name])) {
        targetElement = mutationResult;
        let customData;

        if (customAdd) {
          customData = customAdd({
            query: element.name,
            type: 'array',
            data: data[element.name],
            variables
          });
        }

        data[element.name] = customData && typeof customData === typeof data[element.name] ? customData : (0, _insertElement.default)({
          mutationResult,
          data: data[element.name],
          insertion,
          field,
          ordering,
          errors,
          ID,
          queryName: element.name
        });
      } else if (typeof data[element.name] === 'number') {
        targetElement = data[element.name];
        let customData;

        if (customAdd) {
          customData = customAdd({
            query: element.name,
            type: 'number',
            data: data[element.name],
            variables
          });
        }

        data[element.name] = customData && typeof customData === typeof data[element.name] ? customData : data[element.name] + 1;
      } else if (typeof data[element.name] === 'string') {
        targetElement = data[element.name];
        let customData;

        if (customAdd) {
          customData = customAdd({
            query: element.name,
            type: 'string',
            data: data[element.name],
            variables
          });
        }

        data[element.name] = customData && typeof customData === typeof data[element.name] ? customData : data[element.name];
      } else if (typeof data[element.name] === 'object') {
        targetElement = data[element.name];
        let customData;

        if (customAdd) {
          customData = customAdd({
            query: element.name,
            type: 'object',
            data: data[element.name],
            variables
          });
        }

        data[element.name] = customData && typeof customData === typeof data[element.name] && !Array.isArray(customData) && operation !== customData ? customData : data[element.name];
      }
    }

    proxy.writeQuery(_objectSpread({}, proxyObject, {
      data
    }));
  } catch (e) {
    console.log(e);
  }

  return targetElement;
};

exports.default = _default;
//# sourceMappingURL=index.js.map